Package org.apache.commons.math3.ode

# Interface FirstOrderFieldIntegrator<T extends RealFieldElement<T>>

Type Parameters:
  `T` - the type of the field elements

All Known Implementing Classes:
  `AbstractFieldIntegrator`, `AdamsBashforthFieldIntegrator`, `AdamsFieldIntegrator`, `AdamsMoultonFieldIntegrator`, `AdaptiveStepsizeFieldIntegrator`, `ClassicalRungeKuttaFieldIntegrator`, `DormandPrince54FieldIntegrator`, `DormandPrince853FieldIntegrator`, `EmbeddedRungeKuttaFieldIntegrator`, `EulerFieldIntegrator`, `GillFieldIntegrator`, `HighamHall54FieldIntegrator`, `LutherFieldIntegrator`, `MidpointFieldIntegrator`, `MultistepFieldIntegrator`, `RungeKuttaFieldIntegrator`, `ThreeEighthesFieldIntegrator`

public interface FirstOrderFieldIntegrator<T extends RealFieldElement<T>>
This interface represents a first order integrator for differential equations.

The classes which are devoted to solve first order differential equations should implement this interface. The problems which can be handled should implement the `FirstOrderDifferentialEquations` interface.

Since:
  3.6
See Also:
  - `FirstOrderFieldDifferentialEquations`

## Method Summary

Modifier and Type
Method
Description
`void`
`addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount)`
Add an event handler to the integrator.
`void`
`addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount, BracketedRealFieldUnivariateSolver<T> solver)`
Add an event handler to the integrator.
`void`
`addStepHandler(FieldStepHandler<T> handler)`
Add a step handler to this integrator.
`void`
`clearEventHandlers()`
Remove all the event handlers that have been added to the integrator.
`void`
`clearStepHandlers()`
Remove all the step handlers that have been added to the integrator.
`T`
`getCurrentSignedStepsize()`
Get the current signed value of the integration stepsize.
`FieldODEStateAndDerivative<T>`
`getCurrentStepStart()`
Get the current value of the step start time ti.
`int`
`getEvaluations()`
Get the number of evaluations of the differential equations function.
`Collection<FieldEventHandler<T>>`
`getEventHandlers()`
Get all the event handlers that have been added to the integrator.
`int`
`getMaxEvaluations()`
Get the maximal number of functions evaluations.
`String`
`getName()`
Get the name of the method.
`Collection<FieldStepHandler<T>>`
`getStepHandlers()`
Get all the step handlers that have been added to the integrator.
`FieldODEStateAndDerivative<T>`
`integrate(FieldExpandableODE<T> equations, FieldODEState<T> initialState, T finalTime)`
Integrate the differential equations up to the given time.
`void`
`setMaxEvaluations(int maxEvaluations)`
Set the maximal number of differential equations function evaluations.

## Method Details

### getName

String getName()
Get the name of the method.

Returns:
  name of the method

### addStepHandler

void addStepHandler(FieldStepHandler<T> handler)
Add a step handler to this integrator.

The handler will be called by the integrator for each accepted step.

Parameters:
  `handler` - handler for the accepted steps
See Also:
  - `getStepHandlers()`
  - `clearStepHandlers()`

### getStepHandlers

Collection<FieldStepHandler<T>> getStepHandlers()
Get all the step handlers that have been added to the integrator.

Returns:
  an unmodifiable collection of the added events handlers
See Also:
  - `addStepHandler(FieldStepHandler)`
  - `clearStepHandlers()`

### clearStepHandlers

void clearStepHandlers()
Remove all the step handlers that have been added to the integrator.

See Also:
  - `addStepHandler(FieldStepHandler)`
  - `getStepHandlers()`

### addEventHandler

void addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount)
Add an event handler to the integrator.

The default solver is a 5th order `FieldBracketingNthOrderBrentSolver`.

Parameters:
  `handler` - event handler
  `maxCheckInterval` - maximal time interval between switching function checks (this interval prevents missing sign changes in case the integration steps becomes very large)
  `convergence` - convergence threshold in the event time search
  `maxIterationCount` - upper limit of the iteration count in the event time search events.
See Also:
  - `addEventHandler(FieldEventHandler, double, double, int, org.apache.commons.math3.analysis.solvers.BracketedRealFieldUnivariateSolver)`
  - `getEventHandlers()`
  - `clearEventHandlers()`

### addEventHandler

void addEventHandler(FieldEventHandler<T> handler, double maxCheckInterval, double convergence, int maxIterationCount, BracketedRealFieldUnivariateSolver<T> solver)
Add an event handler to the integrator.

Parameters:
  `handler` - event handler
  `maxCheckInterval` - maximal time interval between switching function checks (this interval prevents missing sign changes in case the integration steps becomes very large)
  `convergence` - convergence threshold in the event time search
  `maxIterationCount` - upper limit of the iteration count in the event time search events.
  `solver` - solver to use to locate the event
See Also:
  - `addEventHandler(FieldEventHandler, double, double, int)`
  - `getEventHandlers()`
  - `clearEventHandlers()`

### getEventHandlers

Collection<FieldEventHandler<T>> getEventHandlers()
Get all the event handlers that have been added to the integrator.

Returns:
  an unmodifiable collection of the added events handlers
See Also:
  - `addEventHandler(FieldEventHandler, double, double, int)`
  - `clearEventHandlers()`

### clearEventHandlers

void clearEventHandlers()
Remove all the event handlers that have been added to the integrator.

See Also:
  - `addEventHandler(FieldEventHandler, double, double, int)`
  - `getEventHandlers()`

### getCurrentStepStart

FieldODEStateAndDerivative<T> getCurrentStepStart()
Get the current value of the step start time ti.

This method can be called during integration (typically by the object implementing the `differential equations` problem) if the value of the current step that is attempted is needed.

The result is undefined if the method is called outside of calls to `integrate`.

Returns:
  current value of the state at step start time ti

### getCurrentSignedStepsize

T getCurrentSignedStepsize()
Get the current signed value of the integration stepsize.

This method can be called during integration (typically by the object implementing the `differential equations` problem) if the signed value of the current stepsize that is tried is needed.

The result is undefined if the method is called outside of calls to `integrate`.

Returns:
  current signed value of the stepsize

### setMaxEvaluations

void setMaxEvaluations(int maxEvaluations)
Set the maximal number of differential equations function evaluations.

The purpose of this method is to avoid infinite loops which can occur for example when stringent error constraints are set or when lots of discrete events are triggered, thus leading to many rejected steps.

Parameters:
  `maxEvaluations` - maximal number of function evaluations (negative values are silently converted to maximal integer value, thus representing almost unlimited evaluations)

### getMaxEvaluations

int getMaxEvaluations()
Get the maximal number of functions evaluations.

Returns:
  maximal number of functions evaluations

### getEvaluations

int getEvaluations()
Get the number of evaluations of the differential equations function.

The number of evaluations corresponds to the last call to the `integrate` method. It is 0 if the method has not been called yet.

Returns:
  number of evaluations of the differential equations function

### integrate

FieldODEStateAndDerivative<T> integrate(FieldExpandableODE<T> equations, FieldODEState<T> initialState, T finalTime) throws NumberIsTooSmallException, MaxCountExceededException, NoBracketingException
Integrate the differential equations up to the given time.

This method solves an Initial Value Problem (IVP).

Since this method stores some internal state variables made available in its public interface during integration (`getCurrentSignedStepsize()`), it is not thread-safe.

Parameters:
  `equations` - differential equations to integrate
  `initialState` - initial state (time, primary and secondary state vectors)
  `finalTime` - target time for the integration (can be set to a value smaller than `t0` for backward integration)
Returns:
  final state, its time will be the same as `finalTime` if integration reached its target, but may be different if some `FieldEventHandler` stops it at some point.
Throws:
  `NumberIsTooSmallException` - if integration step is too small
  `MaxCountExceededException` - if the number of functions evaluations is exceeded
  `NoBracketingException` - if the location of an event cannot be bracketed